
uniform float time;
#ifdef vertex

buffer pose{
	mat4 joint[];
};

in vec2 position;
in vec4 joint_weights;
in ivec4 joint_indices;
out vec2 uv;

uniform mat4 object_to_clip;

uniform int asd;

void main() {
	uv = position;
	float weight = .0;
	vec4 pos = vec4(.0);
	for(int i = 0; i<4; ++i) {
		if(joint_indices[i]!=-1 && time>.0f) {
			pos += joint_weights[i] * joint[joint_indices[i]] * vec4(position, .0, 1.0);
			weight += joint_weights[i];
		}
	}
	if(weight>.0)
		pos /= weight;
	else
		pos = joint[0]*vec4(position, .0, 1.0);
	vec3 wpos = (object_to_clip*pos).xyz;
	wpos.z += .6;
	gl_Position = vec4(wpos, 1.0);
}

#endif

#ifdef fragment

in vec2 uv;

uniform sampler2D image;

out vec4 out_color;

void main() {
	out_color = texture(image, uv)*vec2(.6,smoothstep(.0, .2, uv.y)).xxxy;
}

#endif
