
#ifdef vertex

buffer pose{
	mat4 joint[];
};

in vec2 position;
in vec4 joint_weights;
in ivec4 joint_indices;

out vec2 uv;

uniform mat4 object_to_clip;

uniform int asd;

void main() {
	uv = position;
	float weight = .0;
	vec4 pos = vec4(.0);
	for(int i = 0; i<4; ++i) {
		if(joint_indices[i]!=-1) {
			pos += joint_weights[i] * joint[joint_indices[i]] * vec4(position, .0, 1.0);
			weight += joint_weights[i];
		}
	}
	if(weight>.0)
		pos /= weight;
	else
		pos = joint[0]*vec4(position, .0, 1.0);
	pos.xyz = (object_to_clip*pos).xyz;
	pos.z -= .5;
	gl_Position = vec4(pos.xyz, 1.0);
}

#endif

#ifdef fragment

in vec2 uv;

uniform float time;
uniform sampler2D image;

out vec4 out_color;

void main() {
	out_color = texture(image, uv*8.0f)*smoothstep(32.0, 35.0, time+uv.y*2.0)*(.6+.4*sin(uv.x*12.0+time+sin(uv.y*5.0)))*max(smoothstep(58.0, 53.0, time+uv.y*2.0)*smoothstep(.8, .7, uv.x), float(time>70))*vec2(1.0, .6).xxxy;
}

#endif
